//--------------------------------------------------------------------
// Projekt: "Black and Red"
// main.c
// Autor: Lukas Brozio
// Datum: 02.04.2008
//--------------------------------------------------------------------





#include <acknex.h>
#include <windows.h>


#define SCHWARZ 0
#define ROT 1



BMAP* stein_schwarz_tga = "stein_schwarz.tga";
BMAP* stein_rot_tga = "stein_rot.tga";
BMAP* maus_tga = "maus.tga";


PANEL* pn_hintergrund =
{
	bmap = "hintergrund.tga";
	flags = VISIBLE;
}




var anz_punkte = 0;
var zeit = 60;
char globaler_spielzustand = 0;


FONT* punkte_font = "Arial#20b";
PANEL* pn_punkte =
{
	digits(16,16,"Score: %.0f",punkte_font,1,anz_punkte);
	digits(552,16,"Time: %02.0f",punkte_font,1,zeit);
	//digits(16,444,"Leben: %.0f",punkte_font,1,leben);
	layer = 2;
	flags = VISIBLE;
}


TEXT* txt_vor_dem_spiel =
{
	pos_x = 176;
	pos_y = 128;
	font = punkte_font;
	string ("Welcome to \"Black and Red\", a\ngame by Lukas Brozio made for the\n\"100 lines of code\" contest in 2008.\nYou have to move the black sqares\nto the left black area and the red\nones to the red area. The smaller\nand the faster the square is, the\nmore points you get. If you move a\nsquare to the wrong area, you lose\n10 seconds of time.\nHave fun!\n\n\n\n(Press any key)");
	layer = 3;
	flags = VISIBLE;
}


STRING* str_nach_den_spiel = "";


TEXT* txt_nach_dem_spiel =
{
	pos_x = 172;
	pos_y = 160;
	font = punkte_font;
	string (str_nach_den_spiel);
	layer = 3;
	flags = VISIBLE;
}


SOUND* falsch_wav = "falsch.wav";
SOUND* richtig_wav = "richtig.wav";
SOUND* ende_wav = "ende.wav";




void create_stein (BMAP* bitmap_bmp, char farbe, var _scale_x, var _scale_y, var punkte, var geschwindigkeit)
{
	PANEL* _panel;
	_panel = pan_create("",1);
	_panel.bmap = bitmap_bmp;
	_panel.flags |= VISIBLE;
	
	_panel.scale_x = _scale_x;
	_panel.scale_y = _scale_y;
	


	char but_click;
	char but_ueber;
	
	
	var bak_mouse_x;
	var bak_mouse_y;
	
	bak_mouse_x = mouse_pos.x;
	bak_mouse_y = mouse_pos.y;
	
	
	
	var richtung;
	
	richtung = integer(random(2));
	
	
	_panel.pos_x = random(256 - _panel.size_x*_panel.scale_x) + 192 - _panel.size_x*_panel.scale_x/2;
	
	
	
	if (richtung == 0) _panel.pos_y = -64;
	else _panel.pos_y = 480;
	
	
	
	while (1)
	{
		if (!(key_pressed(280)))
		{
			but_click = 0;
		}
		if ((mouse_pos.x >= _panel.pos_x) && (mouse_pos.x < _panel.pos_x + _panel.size_x*_panel.scale_x) && (mouse_pos.y >= _panel.pos_y) && (mouse_pos.y < _panel.pos_y + _panel.size_y*_panel.scale_y)&& ((but_click == 0) || (but_click == 2)))
		{
			but_ueber = 1;
			if (key_pressed(280)) but_click = 2;
		}
		else if (but_ueber != 1) but_ueber = 0;
		if (but_click == 2)
		{
			_panel.pos_x += mouse_pos.x - bak_mouse_x;
			_panel.pos_y += mouse_pos.y - bak_mouse_y;
		}
		else
		{
			if ((_panel.pos_x > 160) && (_panel.pos_x < 480 - _panel.size_x*_panel.scale_x))
			{
				if (richtung == 0) _panel.pos_y += geschwindigkeit/30;
				else _panel.pos_y -= geschwindigkeit/30;
			}
			
		}
		if ((but_click == 0) && (key_pressed(280)))
		{
			but_click = 1;
		}
		bak_mouse_x = mouse_pos.x;
		bak_mouse_y = mouse_pos.y;
		
		
		if (((farbe == 0) && (_panel.pos_x + (_panel.size_x*_panel.scale_x/2) <= 160) && (_panel.pos_y + (_panel.size_y*_panel.scale_y/2) >= 120)  && (_panel.pos_y + (_panel.size_y*_panel.scale_y/2) <= 360)) || ((farbe == 1) && (_panel.pos_x + (_panel.size_x*_panel.scale_x/2) >= 480) && (_panel.pos_y + (_panel.size_y*_panel.scale_y/2) >= 120)  && (_panel.pos_y + (_panel.size_y*_panel.scale_y/2) <= 360)))
		{
			anz_punkte += punkte;
			snd_play(richtig_wav,100,0);
			while(1)
			{
				if (farbe == 0) _panel.pos_x -= 1;
				else _panel.pos_x += 1;
				wait(1);
			}
		}
		
		
		if (((farbe == 1) && (_panel.pos_x + (_panel.size_x*_panel.scale_x/2) <= 160) && (_panel.pos_y + (_panel.size_y*_panel.scale_y/2) >= 120)  && (_panel.pos_y + (_panel.size_y*_panel.scale_y/2) <= 360)) || ((farbe == 0) && (_panel.pos_x + (_panel.size_x*_panel.scale_x/2) >= 480) && (_panel.pos_y + (_panel.size_y*_panel.scale_y/2) >= 120)  && (_panel.pos_y + (_panel.size_y*_panel.scale_y/2) <= 360)))
		{
			snd_play(falsch_wav,100,0);
			zeit -= 10;
			if (zeit < 0) zeit = 0;
			pan_remove(_panel);
			break;
		}
		
		
		
		
		if (globaler_spielzustand == 2) 
		{
			pan_remove(_panel);
			break;
		}
		
		wait(1);
	}
}








STRING* str_temp = "";


void zeit_startup ()
{
	while(globaler_spielzustand == 0) wait(1);
	while(zeit > 0)
	{
		zeit --;
		wait(-1);
	}
	snd_play(ende_wav,100,0);
	globaler_spielzustand = 2;
	str_cpy(str_nach_den_spiel,"Your score is ");
	str_for_num(str_temp,anz_punkte);
	str_cat(str_nach_den_spiel,str_temp);
	str_cat(str_nach_den_spiel,". Thanks for playing!");
	txt_nach_dem_spiel.flags |= VISIBLE;
}



var zufall[3];

void main ()
{
	mouse_map = maus_tga;
	mouse_mode = 3;
	randomize();
	video_window(0,0,112,"Black and Red by Lukas Brozio");
	
	while (!key_any) wait(1);
	globaler_spielzustand = 1;
	txt_vor_dem_spiel.flags &= ~VISIBLE;
	
	while (1)
	{
		zufall[0] = integer(random (100));
		zufall[1] = integer(random (4)) + 1;
		zufall[2] = integer(random (10)) + 1;
		if (zufall[0] >= 50) create_stein (stein_schwarz_tga, SCHWARZ, 1/(zufall[1]+((zufall[1] == 3)*(zufall[0] >= 75))-((zufall[1] == 3)*(zufall[0] < 75))), 1/(zufall[1]+((zufall[1] == 3)*(zufall[0] >= 75))-((zufall[1] == 3)*(zufall[0] < 75))), zufall[2]*(zufall[1]+((zufall[1] == 3)*(zufall[0] >= 75))-((zufall[1] == 3)*(zufall[0] < 75))), zufall[2]*2);
		else create_stein (stein_rot_tga, ROT, 1/(zufall[1]+((zufall[1] == 3)*(zufall[0] >= 75))-((zufall[1] == 3)*(zufall[0] < 75))), 1/(zufall[1]+((zufall[1] == 3)*(zufall[0] >= 75))-((zufall[1] == 3)*(zufall[0] < 75))), zufall[2]*(zufall[1]+((zufall[1] == 3)*(zufall[0] >= 75))-((zufall[1] == 3)*(zufall[0] < 75))), zufall[2]*2);
		wait(1000/zufall[2]);
	}
}